Gecode::Int::NValues::LqInt< VY > Class Template Reference
Other available functionality » Integer propagators

Less or equal to number of values propagator for integer views. More...

`#include <nvalues.hh>`

## Public Member Functions

virtual Propagator * | copy (Space &home)
| Copy propagator during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
Public Member Functions inherited from Gecode::Int::NValues::IntBase< VY >
virtual PropCost | cost (const Space &, const ModEventDelta &) const
| Cost function.
Public Member Functions inherited from Gecode::MixNaryOnePropagator< IntView, PC_INT_DOM, VY, PC_INT_BND >
virtual void | reschedule (Space &home)
| Schedule function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< IntView > &x, VY y)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| LqInt (Home home, ValSet &vs, ViewArray< IntView > &x, VY y)
| Constructor for posting.
| LqInt (Space &home, LqInt< VY > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Int::NValues::IntBase< VY >
| IntBase (Home home, ValSet &vs, ViewArray< IntView > &x, VY y)
| Constructor for posting.
| IntBase (Space &home, IntBase< VY > &p)
| Constructor for cloning p.
void | add (Space &home)
| Add values of assigned views to value set.
void | disjoint (Space &home, Region &r, int *&dis, int &n_dis)
void | eliminate (Space &home)
| Eliminate subsumed views (all values included in the value set vs).
ExecStatus | all_in_valset (Space &home)
| Propagate that all views must take values from value set.
ExecStatus | prune_lower (Space &home, int *dis, int n_dis)
ExecStatus | prune_upper (Space &home, Graph &g)
Protected Member Functions inherited from Gecode::MixNaryOnePropagator< IntView, PC_INT_DOM, VY, PC_INT_BND >
| MixNaryOnePropagator (Space &home, MixNaryOnePropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Additional Inherited Members

Protected Attributes inherited from Gecode::Int::NValues::IntBase< VY >
ValSet | vs
| Value set storing the values of already assigned views.
Protected Attributes inherited from Gecode::MixNaryOnePropagator< IntView, PC_INT_DOM, VY, PC_INT_BND >
ViewArray< IntView > | x
| Array of views.
VY | y
| Single view.

## Detailed Description

template<class VY>
class Gecode::Int::NValues::LqInt< VY >

Less or equal to number of values propagator for integer views.

Requires

#include <gecode/int/nvalues.hh>
nvalues.hh

Definition at line 219 of file nvalues.hh.

## Constructor & Destructor Documentation

## LqInt() [1/2]

template<class VY>

Gecode::Int::NValues::LqInt< VY >::LqInt | ( | Home | home,
|  | ValSet & | vs,
|  | ViewArray< IntView > & | x,
|  | VY | y )

inline protected

Constructor for posting.

Definition at line 41 of file int-lq.hpp.

## LqInt() [2/2]

template<class VY>

Gecode::Int::NValues::LqInt< VY >::LqInt | ( | Space & | home,
|  | LqInt< VY > & | p )

inline protected

Constructor for cloning p.

Definition at line 93 of file int-lq.hpp.

## Member Function Documentation

## copy()

template<class VY>

Propagator * Gecode::Int::NValues::LqInt< VY >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 98 of file int-lq.hpp.

## propagate()

template<class VY>

ExecStatus Gecode::Int::NValues::LqInt< VY >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 112 of file int-lq.hpp.

## post()

template<class VY>

ExecStatus Gecode::Int::NValues::LqInt< VY >::post | ( | Home | home,
|  | ViewArray< IntView > & | x,
|  | VY | y )

inline static

Post propagator for .

Definition at line 48 of file int-lq.hpp.

## dispose()

template<class VY>

size_t Gecode::Int::NValues::LqInt< VY >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Int::NValues::IntBase< VY >.

Definition at line 104 of file int-lq.hpp.

The documentation for this class was generated from the following files:

- gecode/int/nvalues.hh
- gecode/int/nvalues/int-lq.hpp